//---------------------------------------------
// Example program to test the Environment class in C# and .NET
// Bill Nolde 2002
// billnolde@ieee.org
//-------------------------------
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices ;

namespace EnviromentTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
 		[DllImport("user32.dll", SetLastError = true)]
		public static extern int    MessageBox(int hWnd, String text, 
			                           String caption, uint type);

		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ListBox m_listbox;
		private System.Windows.Forms.ListBox m_env_function;
		private System.Windows.Forms.TextBox m_textbox;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button AboutButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.m_listbox = new System.Windows.Forms.ListBox();
			this.m_env_function = new System.Windows.Forms.ListBox();
			this.m_textbox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.AboutButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(656, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Exit";
			this.button1.Click += new System.EventHandler(this.ExitButtonClick);
			// 
			// m_listbox
			// 
			this.m_listbox.HorizontalScrollbar = true;
			this.m_listbox.ItemHeight = 16;
			this.m_listbox.Location = new System.Drawing.Point(8, 120);
			this.m_listbox.Name = "m_listbox";
			this.m_listbox.ScrollAlwaysVisible = true;
			this.m_listbox.Size = new System.Drawing.Size(528, 276);
			this.m_listbox.TabIndex = 1;
			// 
			// m_env_function
			// 
			this.m_env_function.ItemHeight = 16;
			this.m_env_function.Items.AddRange(new object[] {
																"Environment",
																"Command Line",
																"Current Directory",
																"Exit Code",
																"Machine Name",
																"New Line Characters",
																"OS Version",
																"Stack Trace",
																"System Directory",
																"Tick Count",
																"Use Domain Name",
																"User Interactive",
																"User Name",
																"Version",
																"Working Set",
																"Logical Drives",
																"Folders Paths"});
			this.m_env_function.Location = new System.Drawing.Point(560, 104);
			this.m_env_function.Name = "m_env_function";
			this.m_env_function.Size = new System.Drawing.Size(160, 276);
			this.m_env_function.TabIndex = 6;
			this.m_env_function.SelectedIndexChanged += new System.EventHandler(this.m_env_function_SelectedIndexChanged);
			// 
			// m_textbox
			// 
			this.m_textbox.AcceptsReturn = true;
			this.m_textbox.AcceptsTab = true;
			this.m_textbox.Location = new System.Drawing.Point(8, 64);
			this.m_textbox.Multiline = true;
			this.m_textbox.Name = "m_textbox";
			this.m_textbox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.m_textbox.Size = new System.Drawing.Size(528, 312);
			this.m_textbox.TabIndex = 7;
			this.m_textbox.Text = "";
			this.m_textbox.Visible = false;
			this.m_textbox.WordWrap = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(240, 40);
			this.label1.Name = "label1";
			this.label1.TabIndex = 8;
			this.label1.Text = "Results";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(576, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 32);
			this.label2.TabIndex = 9;
			this.label2.Text = "Environment Members";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// AboutButton
			// 
			this.AboutButton.Location = new System.Drawing.Point(656, 40);
			this.AboutButton.Name = "AboutButton";
			this.AboutButton.TabIndex = 10;
			this.AboutButton.Text = "About";
			this.AboutButton.Click += new System.EventHandler(this.AboutButtonClick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(744, 399);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.AboutButton,
																		  this.label2,
																		  this.label1,
																		  this.m_textbox,
																		  this.m_env_function,
																		  this.m_listbox,
																		  this.button1});
			this.Name = "Form1";
			this.Text = "C# .NET Environment Sample Program 2002   Bill Nolde";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
//-------------------------------------------------------------
private void ExitButtonClick(object sender, System.EventArgs e)
{
	Application.Exit();		
}
//------------------------------------------------------------
private void m_env_function_SelectedIndexChanged(object sender, System.EventArgs e)
{
//	MessageBeep(1000);
	int nDx = m_env_function.SelectedIndex;
	try
	{
		m_listbox.Visible = true;
		m_textbox.Visible = false;
		m_listbox.Items.Clear();
		switch(nDx)
		{
		case 0:
			IDictionary id;
			String sString;
			ArrayList values = new ArrayList();

			m_listbox.Items.Clear ();	
			id = Environment.GetEnvironmentVariables();
			foreach (DictionaryEntry myEntry in id) 
			{
				sString = myEntry.Key.ToString();
				sString += "=";
				sString += myEntry.Value.ToString();
				m_listbox.Items.Add(sString);
			}
			m_listbox.SetSelected(0, true);
			break;
		
		case 1:
			m_listbox.Items.Clear ();
			string[] args = new String[50];
			args = Environment.GetCommandLineArgs();
			for (int i=0; i<args.Length; i++) 
					m_listbox.Items.Add(args[i]);
			break;

		case 2:
			m_listbox.Items.Add( Environment.CurrentDirectory);
		   break;
		case 3:			
			m_listbox.Items.Add( Environment.ExitCode.ToString());
			break;
		case 4:
			m_listbox.Items.Add( Environment.MachineName);				
			break;
		case 5:
			string str="";
			string nl = Environment.NewLine.ToString();
			for(int i=0; i<nl.Length; i++)	{
				char ch =  nl[i];
				str = String.Format("{0:2X} ",ch);
				int ti = (int) ch;
				str = ti.ToString("X2") + "";
			}
				m_listbox.Items.Add(str);
			break;
		case 6:
			m_listbox.Items.Add( Environment.OSVersion.ToString());				
			break;
		case 7:
			m_listbox.Visible = false;
			m_textbox.Visible = true;
			m_textbox.Text = Environment.StackTrace;				
			break;
		case 8:
			m_listbox.Items.Add( Environment.SystemDirectory);				
			break;
		case 9:
			m_listbox.Items.Add( Environment.TickCount.ToString());				
			break;
		case 10:
			m_listbox.Items.Add( Environment.UserDomainName);			
			break;
		case 11:
			bool ui = Environment.UserInteractive;
			if (ui == true) m_listbox.Items.Add( "User in interactive mode");
			else m_listbox.Items.Add( "Not interactive Service Process or from inside a Web application");
			break;
		case 12:
			m_listbox.Items.Add( Environment.UserName);			
			break;
		case 13:
			m_listbox.Items.Add( Environment.Version.ToString());			
			break;
		case 14:
			m_listbox.Items.Add( Environment.WorkingSet.ToString());			
			break;
		case 15:
			m_listbox.Items.Clear ();
			string[] Drives = new String[50];
			Drives = Environment.GetLogicalDrives();
			for (int i=0; i<Drives.Length; i++) 
				m_listbox.Items.Add(Drives[i]);
			break;
		case 16:
			string spf;
			m_listbox.Items.Clear ();
			spf = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
			m_listbox.Items.Add("ApplicationData=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData);
			m_listbox.Items.Add("CommonApplicationData=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles);
			m_listbox.Items.Add("CommonProgramFiles=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Cookies);
			m_listbox.Items.Add("Cookies=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
			m_listbox.Items.Add("DesktopDirectory=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Favorites);
			m_listbox.Items.Add("Favorites=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.History);
			m_listbox.Items.Add("History=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.InternetCache);
			m_listbox.Items.Add("InternetCache=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData);
			m_listbox.Items.Add("LocalApplicationData=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
			m_listbox.Items.Add("Personal=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles);
			m_listbox.Items.Add("ProgramFiles=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Programs);
			m_listbox.Items.Add("Programs=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Recent);
			m_listbox.Items.Add("Recent=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.SendTo);
			m_listbox.Items.Add("SendTo=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.StartMenu);
			m_listbox.Items.Add("StartMenu=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Startup);
			m_listbox.Items.Add("Startup=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.System);
			m_listbox.Items.Add("System=" + spf);
			spf = Environment.GetFolderPath(Environment.SpecialFolder.Templates);
			m_listbox.Items.Add("Templates=" + spf);
			break;  
		} 
	}
	catch (Exception excpt)
	{
		m_listbox.Items.Add( "Exception occured " + excpt.Message);
	} 
}
//------------------------------------------------------
private void AboutButtonClick(object sender, System.EventArgs e)
{
	MessageBox(0,"Environment  class Example" +
		         "\n      for the .NET Framework" +
		         "\n              Bill Nolde" +
				 "\n        billnolde@ieee.org","",0);
		
}
//------------------------------------------------------
	} //end class
}     //end namespace